/*
 * Copyright 1994, 1995 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#include <Vpf/vpf.h>

#define min(a,b) (a < b ? a : b)
#define max(a,b) (a > b ? a : b)

/*****************************************************************************/

VpfExtent::VpfExtent (double x1, double y1, double x2, double y2) {
    this->x1 = x1;
    this->y1 = y1;
    this->x2 = x2;
    this->y2 = y2;
}

VpfExtent::VpfExtent (extent_type et) {
    this->x1 = et.x1;
    this->y1 = et.y1;
    this->x2 = et.x2;
    this->y2 = et.y2;
}

VpfExtent::VpfExtent () {}

int VpfExtent::contained (VpfExtent& extent2) {
    return ::contained( *this, extent2 );
}

int VpfExtent::completely_within (VpfExtent& extent2) {
    return ::completely_within( *this, extent2 );
}

int VpfExtent::fwithin (double x, double y) {
    return ::fwithin( x, y, *this );
}

VpfExtent VpfExtent::operator+ (VpfExtent& b) {
    VpfExtent m;
    
    m.x1 = min(x1, b.x1);
    m.y1 = min(y1, b.y1);
    m.x2 = max(x2, b.x2);
    m.y2 = max(y2, b.y2);
    return m;
}
